#!/bin/sh
# This program is licensed under the GNU GPL version 2 or later.
-# (c) Richard "RichiH" Hartmann <richih.mailinglist@gmail.com>, 2011-2012
+# (c) Richard "RichiH" Hartmann <richih.mailinglist@gmail.com>, 2011-2013
# For details, see LICENSE. To submit patches, you have to agree to
# license your code under the GNU GPL version 2 or later.
+# While the following is not legally binding, the author would like to
+# explain the choice of GPLv2+ over GPLv3+.
+# The author prefers GPLv3+ over GPLv2+ but feels it's better to maintain
+# full compability with git. In case git ever changes its licensing terms,
+# which is admittedly extremely unlikely to the point of being impossible,
+# this software will most likely follow suit.
+SELF=$(basename $0)
+VERSION='1.2'
+
+fatal() {
+ echo "$SELF: fatal: $1" >&2
+ exit $2
+}
+
+# We need to run getops as soon as possible so we catch -d and other
+# options that will modify our behaviour.
+# Commands are handled at the end of this script.
+while getopts "c:dv" flag; do
+ if [ "$1" = '-d' ] || [ "$1" = '--debug' ]; then
+ set -vx
+ VCSH_DEBUG=1
+ elif [ "$1" = '-v' ];then
+ VCSH_VERBOSE=1
+ elif [ "$1" = '-c' ];then
+ VCSH_OPTION_CONFIG=$OPTARG
+ fi
+ shift 1
+done
+
+source_all() {
+ # Source file even if it's in $PWD and does not have any slashes in it
+ case "$1" in
+ */*) . "$1";;
+ *) . "$PWD/$1";;
+ esac;
+}
+
+
+# Read configuration and set defaults if anything's not set
[ -n "$VCSH_DEBUG" ] && set -vx
[ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
+
+# Read configuration files if there are any
+[ -r "/etc/vcsh/config" ] && . "/etc/vcsh/config"
[ -r "$XDG_CONFIG_HOME/vcsh/config" ] && . "$XDG_CONFIG_HOME/vcsh/config"
+if [ -n "$VCSH_OPTION_CONFIG" ]; then
+ # Source $VCSH_OPTION_CONFIG if it can be read and is in $PWD of $PATH
+ if [ -r "$VCSH_OPTION_CONFIG" ]; then
+ source_all "$VCSH_OPTION_CONFIG"
+ else
+ fatal "Can not read configuration file '$VCSH_OPTION_CONFIG'" 1
+ fi
+fi
[ -n "$VCSH_DEBUG" ] && set -vx
+
+# Read defaults
[ -z "$VCSH_REPO_D" ] && VCSH_REPO_D="$XDG_CONFIG_HOME/vcsh/repo.d"
[ -z "$VCSH_HOOK_D" ] && VCSH_HOOK_D="$XDG_CONFIG_HOME/vcsh/hooks-enabled"
[ -z "$VCSH_BASE" ] && VCSH_BASE="$HOME"
[ -z "$VCSH_GITIGNORE" ] && VCSH_GITIGNORE='exact'
-SELF=$(basename $0)
help() {
- echo "usage: $SELF <args>
+ echo "usage: $SELF <options> <command>
+ options:
+ -c <file> Source file
+ -d Enable debug mode
+ -v Enable verbose mode
+
+ commands:
clone <remote> \\
[<repo>] Clone from an existing repository
+ delete <repo> Delete an existing repository
+ enter <repo> Enter repository; spawn new instance of \$SHELL
help Display this help text
- delete Delete an existing repository
- enter Enter repository; spawn new instance of \$SHELL
init <repo> Initialize a new repository
list List all repositories
list-tracked List all files tracked by vcsh
<newname> Rename repository
run <repo> \\
<command> Use this repository
- setup Set up repository with recommended settings
- which <substring> Find substring in any tracked file name
+ setup <repo> Set up repository with recommended settings
+ version Print version information
+ which <substring> Find substring in name of any tracked file
write-gitignore \\
<repo> Write .gitignore.d/<repo> via git ls-files
if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
}
-fatal() {
- echo "$SELF: fatal: $1" >&2
- exit $2
-}
-
error() {
echo "$SELF: error: $1" >&2
}
delete() {
cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
use
- info "This operation WILL DETROY DATA!"
+ info "This operation WILL DESTROY DATA!"
files=$(git ls-files)
echo "These files will be deleted:
for file in $files; do
rm -f $file || info "could not delete '$file', continuing with deletion"
done
- rmdir "$GIT_DIR" || error "could not delete '$GIT_DIR'"
+ rm -rf "$GIT_DIR" || error "could not delete '$GIT_DIR'"
}
enter() {
hook() {
for hook in $VCSH_HOOK_D/$1* $VCSH_HOOK_D/$VCSH_REPO_NAME.$1*; do
[ -x "$hook" ] || continue
- info "executing '$hook'"
+ verbose "executing '$hook'"
"$hook"
done
}
}
list() {
- for i in "$VCSH_REPO_D"/*.git; do
- echo $(basename "$i" .git)
+ for repo in "$VCSH_REPO_D"/*.git; do
+ [ -d "$repo" ] && [ -r "$repo" ] && echo $(basename "$repo" .git)
done
}
run() {
hook pre-run
use
- $VCSH_EXTERNAL_COMMAND
+ "$@"
hook post-run
}
tempfile=$(mktemp) || fatal "could not create tempfile" 51
echo '*' > "$tempfile" || fatal "could not write to '$tempfile'" 57
for gitignore in $gitignores; do
- echo "$gitignore" | sed 's/^/!/' >> "$tempfile" || fatal "could not write to '$tempfile'" 57
+ echo "$gitignore" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57
if [ x$VCSH_GITIGNORE = x'recursive' ] && [ -d "$gitignore" ]; then
- { echo "$gitignore/*" | sed 's/^/!/' >> "$tempfile" || fatal "could not write to '$tempfile'" 57; }
+ { echo "$gitignore/*" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57; }
fi
done
if diff -N "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" > /dev/null; then
fi
if [ "$1" = 'clone' ]; then
- [ -z $2 ] && fatal "$1: please specify a remote" 1
+ [ -z "$2" ] && fatal "$1: please specify a remote" 1
export VCSH_COMMAND="$1"
GIT_REMOTE="$2"
[ -n "$3" ] && VCSH_REPO_NAME="$3" || VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
export VCSH_REPO_NAME
export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+elif [ "$1" = 'version' ]; then
+ echo "$SELF $VERSION"
+ exit
elif [ "$1" = 'which' ]; then
[ -z "$2" ] && fatal "$1: please specify a filename" 1
[ -n "$3" ] && fatal "$1: too many parameters" 1
export VCSH_REPO_NAME="$2"
export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
[ "$VCSH_COMMAND" = 'rename' ] && export GIT_DIR_NEW="$VCSH_REPO_D/$3.git"
- [ "$VCSH_COMMAND" = 'run' ] && shift 2 && export VCSH_EXTERNAL_COMMAND="$*"
+ [ "$VCSH_COMMAND" = 'run' ] && shift 2
[ "$VCSH_COMMAND" = 'write-gitignore' ]
elif [ "$1" = 'list' ] ||
[ "$1" = 'list-tracked' ]; then
export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
[ -d $GIT_DIR ] || { help; exit 1; }
shift 1
- export VCSH_EXTERNAL_COMMAND="git $*"
+ set -- "git" "$@"
elif [ -n "$1" ]; then
export VCSH_COMMAND='enter'
export VCSH_REPO_NAME="$1"
verbose "$VCSH_COMMAND begin"
export VCSH_COMMAND=$(echo $VCSH_COMMAND | sed 's/-/_/g')
-$VCSH_COMMAND
+hook pre-command
+$VCSH_COMMAND "$@"
+hook post-command
verbose "$VCSH_COMMAND end, exiting"